# Copyright 3000 Test Tester. All rights reserved.
#
# This file was generated by BlueCat Automation Toolkit (BATK).
# Portions which reproduce template contents from BATK are Copyright 2023 BlueCat Networks Inc.
# Other contents are owned by their authors.
"""Routes and back-end implementation of workflow "tester_workflow"."""

from bluecat.gateway.decorators import (
    api_exc_handler,
    page_exc_handler,
    require_permission,
)
from bluecat.util import no_cache

from .base import bp

from flask import send_from_directory
from pathlib import Path


@bp.route("/")
@page_exc_handler(default_message='Failed to load page "tester_workflow".')
@require_permission("tester_workflow")
def page():
    """
    Render page "tester_workflow".

    :return: Response with the page's HTML.
    """
    return send_from_directory(
        Path(__file__).parent, "html/testerWorkflow/index.html"
    )



@bp.route("/", methods=["POST"])
@no_cache
@api_exc_handler(default_message="Failed to perform the action.")
@require_permission("tester_workflow")
def api_post_tester_workflow():
    """
    Perform an action based on the provided parameters.
    """
    # Validate the parameters.

    # Perform the action.

    # Respond with success.
    return {
        "message": "Operation successfully completed.",
    }

@bp.route("/data")
@page_exc_handler(default_message='Failed to load page "tester_workflow" data.')
@require_permission("tester_workflow")
def data():
    """
    Return data for page "tester_workflow".

    :return: Response with data
    """
    # return form data

    return {
        #"field_1": initial_field1_value,
    }
