# Copyright 3000 Best Tester
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
#
# This file was generated by BlueCat Automation Toolkit (BATK).
# Portions which reproduce template contents from BATK are Copyright 2023 BlueCat Networks Inc.
# Other contents are owned by their authors.
"""Routes and back-end implementation of workflow "test_workflow_name"."""
from pathlib import Path

from flask import g, jsonify, request, render_template, send_from_directory

from bluecat.gateway.decorators import (
    api_exc_handler,
    page_exc_handler,
    require_permission,
)
from bluecat.util import no_cache

from .base import bp


@bp.route("/")
@page_exc_handler(default_message='Failed to load page "test_workflow_name".')
@require_permission("test_workflow_name")
def page():
    """
    Render page "test_workflow_name".

    :return: Response with the page's HTML.
    """
    # You may return the contents of a static file.
    # return send_from_directory(
    #     Path(__file__).parent, "html/testWorkflowName/index.html"
    # )

    # You may render a Jinja template.
    # return render_template("test_workflow_name.html")

    # The following is a placeholder response. Replace it with your implementation.
    return f"""\
<!DOCTYPE html>
<html lang="en">
    <head>
        <title>501: Not Implemented</title>
    </head>
    <body>
        <h1>Empty page for {request.method} {request.path}</h1>
        <h2>This page currently does nothing. Replace the implementation of this page with your own.</h2>
    </body>
</html>
""", 501


@bp.route("/", methods=["POST"])
@no_cache
@api_exc_handler(default_message="Failed to perform the action.")
@require_permission("test_workflow_name")
def api_post_test_workflow_name():
    """
    Perform an action based on the provided parameters.
    """
    # Validate the parameters.

    # Perform the action.

    # Respond with success.
    return {
        "message": "Operation successfully completed.",
    }
